<?php 
include_once(NB_DIR .'/functions.php'); 
?>

<div class="wrap lcwp_form">  
    <?php echo '<h2 class="lcwp_page_title">Swift Box - ' . esc_html__('Manage Boxes', 'nb_ml') . "</h2>"; ?>  

    <div id="poststuff" class="metabox-holder has-right-sidebar">
    	
        
        <?php // SIDEBAR ?>
        <div id="side-info-column" class="inner-sidebar">
          <form class="form-wrap">	
           
           <div class="postbox lcwp_sidebox_meta">
            	<h3 class="hndle"><?php esc_attr_e('Add Box', 'nb_ml') ?></h3> 
				<div class="inside">
                	<input type="text" name="nb_name" value="" id="nb_name" maxlenght="100" placeholder="Box Name" /> 
                    <input type="button" name="add_box" id="add_box" value="<?php esc_attr_e('Add', 'nb_ml') ?>" class="button-primary" />
                </div>
            </div>
           
            <div id="nb_boxes_list" class="postbox lcwp_sidebox_meta">
            	<h3 class="hndle"><?php esc_attr_e('Boxes List', 'nb_ml') ?></h3> 
				<div class="inside"></div>
            </div>
            
            <div id="save_nb_box" class="postbox lcwp_sidebox_meta nb_displaynone">
            	<input type="button" name="save-box" value="<?php esc_attr_e('Save box', 'nb_ml') ?>" class="button-primary" />
                
                <?php if(get_option('nb_preview_pag')) : ?>
                <input type="button" id="preview_box" value="<?php esc_attr_e('Preview', 'nb_ml') ?>" class="button-secondary" pv-url="<?php echo get_permalink(get_option('nb_preview_pag')) ?>" />
                <?php endif; ?>
            </div>
          </form>	 
        </div>
    	
        
        
        <?php // PAGE CONTENT ?>
        <div id="post-body">
        <div id="post-body-content" class="nb_builder lcwp_table">
            <p><?php esc_attr_e('Select a box', 'nb_ml') ?> ..</p>
        </div>
        </div>
        
        
        <br class="clear">
    </div>
</div>  




<?php // DATE LEGEND CODE //////////////// ?>
<div class="nb_displaynone">
	<table id="nb_date_legend" class="val_list ">
      <tbody><tr>
        <th>Placeholder</th>
        <th>Description</th>
        <th>Example</th> 
      </tr>
    
      <tr>
        <td>SS</td>
        <td>seconds (with leading zeros)</td>
        <td>20</td>
      </tr>  
      <tr>
        <td>MM</td>
        <td>minutes (with leading zeros)</td>
        <td>05</td>
      </tr>
      
      <tr>
        <td>HHH</td>
        <td>hours with AM/PM</td>
        <td>9 AM</td>
      </tr>
      <tr>
        <td>HH</td>
        <td>hours (with leading zeros)</td>
        <td>09</td>
      </tr> 
      <tr>
        <td>H</td>
        <td>hours (without leading zeros)</td>
        <td>9</td>
      </tr>
     
      <tr>
        <td>dddd</td>
        <td>day with Monday-Sunday format</td>
        <td>Saturday</td>
      </tr>
      <tr>
        <td>ddd</td>
        <td>day with Mon-Sun format</td>
        <td>Sat</td>
      </tr> 
      <tr>
        <td>dd</td>
        <td>day number (with leading zeros)</td>
        <td>06</td>
      </tr>
      <tr>
        <td>d</td>
        <td>day number (without leading zeros)</td>
        <td>6</td>
      </tr>
      
      <tr>
        <td>mmmm</td>
        <td>month with January-December format</td>
        <td>July</td>
      </tr>
      <tr>
        <td>mmm</td>
        <td>day with Jan-Dec format</td>
        <td>Jul</td>
      </tr> 
      <tr>
        <td>mm</td>
        <td>day number (with leading zeros)</td>
        <td>07</td>
      </tr>
      <tr>
        <td>m</td>
        <td>day number (without leading zeros)</td>
        <td>7</td>
      </tr>
     
      <tr>
        <td>yyyy</td>
        <td>year in four digits format</td>
        <td>2013</td>
      </tr>
      <tr>
        <td>mmm</td>
        <td>year in two digits format</td>
        <td>13</td>
      </tr> 
    </tbody>
  </table>
</div>


<script type="text/javascript">
// show dates legend on click
(function($) { 
    "use strict";
    
	$(document).on('click', '.nb_date_guide', function(e) {
		e.preventDefault();
		
		$.magnificPopup.open({
			items : {
				src: '#nb_date_legend',
				type: 'inline'
			},
			mainClass	: 'nb_magpop nb_dates_helper', 
			preloader	: false,
			callbacks	: {
			  beforeOpen: function() {
				if($(window).width() < 800) {
				  this.st.focus = false;
				}
			  },
			}
		});
	});
})(jQuery);  
</script>
<?php ///////////////////////////// ?>




<?php // SCRIPTS ?>
<script type="text/javascript">
(function($) { 
    "use strict"; 
    
    jQuery(document).ready(function($) {
        var nb_is_acting = false;
        var lcwp_nonce = '<?php echo wp_create_nonce('lcwp_nonce') ?>';


        // var for the selected grid
        var sel_box = 0;
        var nb_pag = 1;



        // load boxes list
        var nb_load_boxes = function() {
            $('#nb_boxes_list .inside').html('<div class="lcwp_loading"></div>');

            var data = {
                action: 'nb_boxes_list',
                nb_page: nb_pag,
                lcwp_nonce: lcwp_nonce
            };
            $.ajax({
                type: "POST",
                url: ajaxurl,
                data: data,
                dataType: "json",
                success: function(response){	
                    $('#nb_boxes_list .inside').empty();

                    // get elements
                    nb_pag = response.pag;
                    var tot_pag = response.tot_pag;
                    var boxes = response.elems;	

                    var a = 0;
                    $.each(boxes, function(k, v) {	
                        if(sel_box == v.id) {var sel = 'checked="checked"';}
                        else {var sel = '';}

                        $('#nb_boxes_list .inside').append(
                        '<div class="misc-pub-section-last">'+
                            '<span><input type="radio" name="gl" value="'+ v.id +'" '+ sel +' /></span>'+
                            '<div class="nb_man_box" rel="'+ v.id +'" title="<?php esc_attr_e('toggle actions', 'nb_ml') ?>"><ul>'+
                                '<li class="nb_del_box" title="<?php esc_attr_e('delete box', 'nb_ml') ?>"></li>'+
                                '<li class="nb_rename_box" title="<?php esc_attr_e('rename box', 'nb_ml') ?>"></li>'+
                                '<li class="nb_clone_box" title="<?php esc_attr_e('clone box', 'nb_ml') ?>"></li>'+
                            '</ul></div>'+
                            '<span class="nb_box_tit" title="ID '+ v.id +'">'+ v.name +'</span>'+
                        '</div>');

                        a = a + 1;
                    });

                    if(a == 0) {
                        $('#nb_boxes_list .inside').html('<p><?php esc_attr_e('No existing boxes', 'nb_ml') ?></p>');
                        $('#nb_boxes_list h3.hndle').html('<?php esc_attr_e('Boxes List', 'nb_ml') ?>');
                    }
                    else {
                        // manage pagination elements
                        if(tot_pag > 1) {
                            $('#nb_boxes_list h3.hndle').html('<?php esc_attr_e('Boxes List', 'nb_ml') ?> (<?php esc_attr_e('pag', 'nb_ml') ?> '+ nb_pag +' <?php esc_attr_e('of', 'nb_ml') ?> '+ _tot_pag +')\
                            <span id="nb_next_boxes">&raquo;</span><span id="nb_prev_boxes">&laquo;</span>');
                        } else {
                            $('#nb_boxes_list h3.hndle').html('<?php esc_attr_e('Boxes List', 'nb_ml') ?>');	
                        }

                        // different cases
                        if(nb_pag <= 1) { $('#nb_next_boxes').hide(); }
                        if(nb_pag >= tot_pag) {$('#nb_next_boxes').hide();}	
                    }
                }
            });	
        };
        nb_load_boxes(); // initial load



        // boxes management - toggle buttons visibility
        $('body').on('click', function(e) {
            var $target = $(e.target);

            if($target.hasClass('nb_man_box')) {
                $target.toggleClass('nb_mb_shown');	
                $('.nb_man_box').not($target).removeClass('nb_mb_shown');	
            }
            else {
                $('.nb_man_box').removeClass('nb_mb_shown');		
            }
        });




        // add box
        $('#add_box').on('click', function() {
            var box_name = $('#nb_name').val();

            if($.trim(box_name) != '') {
                var data = {
                    action		: 'nb_add_box',
                    nb_name		: box_name,
                    lcwp_nonce	: lcwp_nonce,
                };

                $.post(ajaxurl, data, function(response) {
                    var resp = $.trim(response); 

                    if(resp == 'success') {
                        lc_wp_popup_message('success', '<?php esc_attr_e('Box added', 'nb_ml') ?>');

                        $('#nb_name').val('');

                        nb_pag = 1;
                        nb_load_boxes();
                    }
                    else {
                        lc_wp_popup_message('error', resp);
                    }
                });	
            }
        });

        // on "enter" key press
        $(document).on("keypress", '#nb_name', function(e) { 
            if(e.keyCode === 13){
                e.preventDefault();	
                $('#add_box').trigger('click');
                return false;
            }
        });



        // clone box
        $(document).on('click', '.nb_clone_box', function() {
            $subj = $(this).parents('.misc-pub-section-last'); 
            var box_id  = $(this).parents('.nb_man_box').attr('rel');


            var new_name = prompt("<?php esc_attr_e("New box name", 'nb_ml') ?>", "");
            if(new_name == null) {return false;}

            var data = {
                action		: 'nb_clone_box',
                box_id		: box_id,
                new_name	: new_name,
                lcwp_nonce	: lcwp_nonce
            };

            jQuery.post(ajaxurl, data, function(response) {
                var resp = jQuery.trim(response); 

                if(resp == 'success') {
                    nb_load_boxes();

                    lc_wp_popup_message('success', "<?php esc_attr_e('Box cloned successfully!', 'nb_ml') ?>");
                } else {
                    lc_wp_popup_message('error', response);
                }
            });
        });


        // rename box
        $(document).on('click', '.nb_rename_box', function() {
            $subj = $(this).parents('.misc-pub-section-last'); 
            var box_id  = $(this).parents('.nb_man_box').attr('rel');


            var new_name = prompt("<?php esc_attr_e("New box name", 'nb_ml') ?>", "");
            if(new_name == null) {return false;}

            // ajax
            var data = {
                action		: 'nb_rename_box',
                box_id		: box_id,
                new_name	: new_name,
                lcwp_nonce	: lcwp_nonce
            };

            jQuery.post(ajaxurl, data, function(response) {
                var resp = jQuery.trim(response); 

                if(resp == 'success') {
                    $subj.find('.nb_box_tit').text(new_name);
                } else {
                    lc_wp_popup_message('error', response);
                }
            });
        });


        // delete box
        $(document).on('click', '.nb_del_box', function() {
            $subj = $(this).parents('.misc-pub-section-last'); 
            var box_id  = $(this).parents('.nb_man_box').attr('rel');

            if(confirm('<?php esc_attr_e('Do you really want to delete this box?', 'nb_ml') ?>')) {
                var data = {
                    action		: 'nb_del_box',
                    box_id		: box_id,
                    lcwp_nonce	: lcwp_nonce
                };

                $.post(ajaxurl, data, function(response) {
                    var resp = $.trim(response); 

                    if(resp == 'success') {
                        // if is this one opened
                        if(sel_box == box_id) {
                            $('.nb_builder').html('<p><?php esc_attr_e('Select a box', 'nb_ml') ?> ..</p>');
                            sel_box = 0;

                            // savegrid box
                            $('#save_nb_box').fadeOut();
                        }

                        $subj.slideUp(function() {
                            $(this).remove();

                            if( $('#nb_boxes_list .inside .misc-pub-section-last').size() == 0) {
                                $('#nb_boxes_list .inside').html('<p><?php esc_attr_e('No existing boxes', 'nb_ml') ?></p>');
                            }
                        });	
                    }
                    else {
                        alert(resp);
                    }
                });
            }
        });



        // select box
        $(document).on('click', '#nb_boxes_list input[type=radio]', function() {
            sel_box = parseInt($(this).val());
            var box_title = $(this).parent().siblings('.nb_box_tit').text();

            $('.nb_builder').html('<div class="lcwp_loading"></div>');

            var data = {
                action: 'nl_box_builder',
                box_id: sel_box 
            };

            $.post(ajaxurl, data, function(response) {
                $('.nb_builder').html(response);
                nb_async_form();

                // add the title
                $('.nb_builder > h2').html(box_title);

                // save and preview boxes
                $('#save_nb_box').fadeIn();
            });	
        });



        // save  box
        $(document).on('click', '#save_nb_box input', function() {

            // sources - data array for each source
            var src_data = [];
            $('.nb_sources .nb_type_block').each(function(i,v) {
                const vals = $(this).find('input:not(.nb_lc_range), select, textarea').serializeArray();
                src_data[i] = vals;
            });

            // check against no sources
            if( $('.nb_sources .nb_type_block').size() == 0 ) {
                alert('<?php esc_attr_e('A news source is needed', 'nb_ml') ?>');
                return false;
            }

            // check against empty fields
            $('#post-body-content .nb_field > input').not('.nb_optional_f').each(function() {
                if( $.trim($(this).val()) == '' ) {
                    alert('<?php esc_attr_e('One or more mandatory fields are empty', 'nb_ml') ?>');
                    nb_abort_saving = true;
                    return false;	
                }
            });
            if(typeof(nb_abort_saving) != 'undefined') {return false;}

            // sanitize & in source data
            src_data = JSON.stringify(src_data);
            src_data = encodeURIComponent(src_data);

            // save
            $('#save_nb_box div').html('<div class="lcwp_loading"></div>');
            var data = 'action=nb_save_box&box_id='+ sel_box +'&src_data='+ src_data +'&'+ $('#nb_box_settings').find('input, select, textarea').serialize();

            $.post(ajaxurl, data, function(response) {
                var resp = $.trim(response); 
                $('#save_nb_box div').empty();	

                if(resp == 'success') {
                    lc_wp_popup_message('success', '<?php esc_attr_e('Box saved', 'nb_ml') ?>');
                }
                else {
                    lc_wp_popup_message('error', resp);
                }
            });
        });



        //////////////////////////////////////////////



        // add news source
        $(document).on('click', '.nb_add_src input', function() {
            var $btn = $(this);
            var type = $(this).parent().find('select').val();
            var $subj = $(this).parents('form.form-wrap').find('.mgom_elements');
            
            if(!nb_is_acting) {
                nb_is_acting = true;
                $btn.fadeTo(200, 0.5); 
                
                // add
                var data = {
                    action: 'nb_add_src',
                    nb_type: type 
                };

                $.post(ajaxurl, data, function(response) {
                    $('.nb_sources').prepend(response);
                    nb_is_acting = false;

                    nb_async_form();
                    $btn.fadeTo(200, 1); 
                });
            }
        });



        // remove news source
        $(document).on('click', '.nb_sources h4 .lcwp_del_row', function() {
            if(confirm('<?php esc_attr_e('Remove news source?', 'nb_ml') ?>')) {
                var $subj = $(this).parents('.nb_type_block');
                $subj.slideUp(function() {
                    $subj.remove();
                });
            }
        });



        // preview box
        $(document).on("click", '#preview_box', function() {
            var url = $(this).attr('pv-url');
            var char = (url.indexOf('?') != -1) ? '&' : '?';

            window.open( url + char + '?nb_preview=' + sel_box ,'_blank');
        });




        ///////////////////////////////////////////



        // async form elements init
        var nb_async_form = function() {

            // sliders
            new lc_range_n_num('.nb_lc_range', {
                unit_width: 17    
            });

            // lc switch
            lc_switch('.nb_lc_check', {
                on_txt      : "<?php echo strtoupper(esc_attr__('yes')) ?>",
                off_txt     : "<?php echo strtoupper(esc_attr__('no')) ?>",   
            });

            // lc select
            new lc_select('.nb_lc_select', {
                wrap_width : '98%',
                addit_classes : ['lcslt-lcwp'],
            });


            // auto-height textarea
            window.nb_textAreaAdjust = function(o) {
                o.style.height = "1px";
                o.style.height = (4 + o.scrollHeight)+"px";
            };
            $('.nb_autoh_textarea').each(function() {
                nb_textAreaAdjust(this);    
            });
        };

    });
})(jQuery); 
</script>
