<?php
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if(!defined('ABSPATH')) exit;



class nb_box_on_elementor extends Widget_Base {
	
	public function get_icon() {
		return 'emtr_lcweb_icon';
	}
	
	public function get_name() {
		return 'swiftbox';
	}

	public function get_categories() {
		return array('general');
	}

	public function get_title() {
		return 'Swift Box';
	}



   protected function _register_controls() {

		// be sure tax are registered
		include_once(NB_DIR .'/admin_menu.php'); 
		register_taxonomy_nb_boxes();
		
		// boxes array
		$boxes_arr = array(); 
		
		$boxes = get_terms('nb_boxes', 'hide_empty=0&orderby=name');
		foreach($boxes as $box) {
			$boxes_arr[ $box->term_id ] = $box->name;
		}
		
		
		///////////////////////////////////////



		// MAIN PARAMS
		$this->start_controls_section(
			'main',
			array(
				'label' => __('Main Parameters', 'nb_ml'),
			)
		);
  
		$this->add_control(
		   'box_id',
		   array(
			  'label' 	=> __('Choose a box', 'nb_ml'),
			  'type' 	=> Controls_Manager::SELECT,
			  'default' => current(array_keys($boxes_arr)),
			  'options' => $boxes_arr
		   )
		);
		
		$this->end_controls_section();
   }


	
	////////////////////////


	protected function render() {
     	$vals = $this->get_settings();
		//var_dump($vals);

		echo do_shortcode('[swiftbox id="'. $vals['box_id'] .'"]');
	}

}
