<?php 
include_once(NB_DIR . '/settings/field_options.php'); 
include_once(NB_DIR . '/functions.php'); 


$ml_key = 'mg_ml';
$cpt_w_tax = nb_get_cpt_with_tax();


// WP pages list
$pages = array(); 	
foreach(get_pages() as $pag) {
	$pages[ $pag->ID ] = $pag->post_title;	
}


// NB-FILTER - manipulate settings tabs
$tabs = array(
	'main_opts' 	=> __('Main Options', $ml_key),
	'styling' 		=> __('Styling', $ml_key),
	'cust_css'		=> __('Custom CSS', $ml_key),
);
$GLOBALS['nb_settings_tabs'] = apply_filters('nb_settings_tabs', $tabs);	




// STRUCTURE
/* tabs index => array( 
	'sect_id' => array(
		'sect_name'	=> name
		'fields'	=> array(
			...
		)
	)
   )
*/

$structure = array();


####################################
########## MAIN OPTIONS ############
####################################
$structure['main_opts'] = array(

	'global' => array(
		'sect_name'	=>  __('Global Settings', $ml_key),
		'fields' 	=> array(
			
			
			'nb_rss2json_token' => array(
				'label' 	=> __("rss2json token", $ml_key),
				'type'		=> 'text',
				'max_val_len'=> 40,
				'fullwidth' => true,
				'note'		=> __("It is <strong>mandatory</strong> to fetch contents from RSS feeds and Pinterest", $ml_key) .' - 
								<a href="https://rss2json.com/me/api_key" target="_blank"><font class="lcwp_sf_note_warn"><strong>'. __("Grab one here", $ml_key) .'</strong></font></a>',
			),	
            'nb_youtube_key' => array(
				'label' 	=> __("Youtube key", $ml_key),
				'type'		=> 'text',
				'max_val_len'=> 50,
				'fullwidth' => true,
				'note'		=> __("It is <strong>mandatory</strong> to fetch Youtube contents", $ml_key) .' - 
								<a href="https://console.cloud.google.com/home/dashboard" target="_blank"><font class="lcwp_sf_note_warn"><strong>'. __("Grab one here", $ml_key) .'</strong></font></a> - <a href="https://www.youtube.com/watch?v=pP4zvduVAqo" target="_blank"><font class="lcwp_sf_note_warn"><strong>'. __("Video guide", $ml_key) .'</strong></font></a>',
			),	
			'spcr1' => array(
				'type' => 'spacer',
			), 
			'nb_min_news_w' => array(
				'label' 	=> __('Minimum news width (horizontal layout)', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 150,
				'max_val'	=> 1000,	
				'step'		=> 10,
				'def'		=> 200,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Sets minimum width for a single news in horizontal layout", $ml_key),
			), 
			'nb_min_news_h' => array(
				'label' 	=> __('Minimum news height (vertical layout)', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 1000,	
				'step'		=> 10,
				'def'		=> 170,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Sets minimum height for a single news in vertical layout", $ml_key),
			), 
			'nb_min_horiz_w' => array(
				'label' 	=> __('Minimum width for horizontal layout', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 250,
				'max_val'	=> 1500,	
				'step'		=> 50,
				'def'		=> 400,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Sets minimum box width to switch from horzontal to vertical mode", $ml_key),
			), 
			'spcr2' => array(
				'type' => 'spacer',
			), 
			'nb_read_more_txt' => array(
				'label' => __('Textual filters - separator', $ml_key),
				'type'	=> 'text',
				'def'	=> '..',
				'note'	=> __("Text used on shortened descriptions end", $ml_key),
			),	
			'nb_date_format' => array(
				'label' => __('Default date format', $ml_key),
				'type'	=> 'text',
				'def'	=> 'd mmmm yyyy',
				'note'	=> __("News date composition - editable for each box", $ml_key) .' <a href="#" class="nb_date_guide">'. __("show guide", $ml_key) .'</a>', // TODO - implement
			),	
			'nb_preloader' => array( // TODO - implement
				'label' => __('Use box and image preloader animation?', $ml_key),
				'type'	=> 'checkbox',
				'def'	=> 1,
				'note'	=> __('If checked, shows a preloader waiting for news to be managed and images to be loaded', $ml_key),
			),  
			'nb_lightbox' => array(
				'label' => __('Lightbox integration?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('If checked, enables lightbox integration for news images and youtube videos', $ml_key),
				
				'js_vis'=> array(
					'linked_field' 	=> 'nb_exp_in_lb',
					'condition'		=> false 
				)
			),  
			'nb_touchswipe' => array(
				'label' => __('TouchSwipe integration?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('If checked, enables swipe and drag events', $ml_key),
			),  
		),
	),
	
	
	'lb_exp_mode' => array(
		'sect_name'	=>  __('Expanded News - Lightbox Mode', $ml_key),
		'fields' 	=> array(
			
			'nb_exp_in_lb' => array(
				'label' => __('Expand news in lightbox?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('If checked, news will be fully shown through the lightbox instead of enlarging box height', $ml_key),
			), 
			'nb_exp_lb_w' => array(
				'label' 	=> __("Lightbox width", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 20,
				'max_val'	=> 100,	
				'step'		=> 1,
				'def'		=> 90,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
				'note'		=> __("Elastic value related to screen's width", $ml_key),
				
				'js_vis'=> array(
					'linked_field' 	=> 'nb_exp_in_lb',
					'condition'		=> true 
				)
			),	 
			'nb_exp_lb_max_w' => array(
				'label' 	=> __("Lightbox width", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 250,
				'max_val'	=> 2000,	
				'step'		=> 50,
				'def'		=> 1000,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Maximum lightbox width on desktop screens", $ml_key),
				
				'js_vis'=> array(
					'linked_field' 	=> 'nb_exp_in_lb',
					'condition'		=> true 
				)
			),
		),
	),
	
	
	'img_size_check' => array(
		'sect_name'	=>  __('Image sizes control', $ml_key),
		'fields' 	=> array(
			
			'nb_touchswipe' => array(
				'label' => __('Check image sizes?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('If checked, resizes images bigger than target ones (improving loading speed)', $ml_key),
			), 
			'gg_filters_padding' => array(
				'label' 	=> __("Maximum sizes <small>(width x height)</small>", $ml_key),
				'type'		=> '2_numbers',
				'min_val'	=> 200,
				'max_val'	=> 1500,	
				'value'		=> 'px',
				'def'		=> array(600, 400),
				'note'		=> __('pixel values', $ml_key)
			),	 
		),
	),
	
	
	'various' => array(
		'sect_name'	=>  __('Various', $ml_key),
		'fields' 	=> array(
			
			'nb_preview_pag' => array(
				'label' => __("Preview container", $ml_key),
				'type'	=> 'select',
				'val' 	=> $pages,
				'note'	=> __('Choose the page to use as preview container', $ml_key), 
			), 
			'nb_js_head' => array(
				'label' => __('Move javascript in head?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('Moves javascript in the website head, use it <strong>ONLY IF</strong> you notice incompatibilities', $ml_key),
			), 
			'nb_inline_css' => array(
				'label' => __('Use custom CSS inline?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, uses custom CSS inline <strong>(useful for multisite installations)</strong>", $ml_key),
			), 
			'nb_no_auto_upd' => array(
				'label' => __('Disable auto-updates?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("Use it only noticing serious backend slowdowns when this plugin is enabled", $ml_key),
			), 
		),
	),
);	

	

// ENABLE CUSTOM POST TYPES + TAXONOMIES
if(!empty($cpt_w_tax)) {

	$structure['main_opts']['cpt'] = array(
			
		'sect_name'	=>  __('Custom post types integration', $ml_key),
		'fields' 	=> array(
            
			'nb_integrate_cpt_f' => array(
				'type'		=> 'custom',
				'callback'	=> 'nb_integrate_cpt',
                'validation'=> array('index'=>'nb_integrate_cpt')
			), 
		),
	); 
}
// END enable custom post type section	
	
	
	
	



####################################
########### STYLING ################
####################################		
$structure['styling'] = array(

	'typography' => array(
		'sect_name'	=>  __('Typography', $ml_key),
		'fields' 	=> array(
			
			
			'nb_title_font_family' => array(
				'label' => __("Titles font family", $ml_key),
				'type'	=> 'text',
				'note'	=> __("Leave empty to use the default one", $ml_key),
			),	
			'nb_txt_font_family' => array(
				'label' => __("Texts font family", $ml_key),
				'type'	=> 'text',
				'note'	=> __("Leave empty to use the default one", $ml_key),
			),	
			'spcr1' => array(
				'type' => 'spacer',
			), 
			
			'nb_is_title_size' => array( // TODO - line height is 6px more than this for every font size
				'label' 	=> __("Titles font size (initial mode)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 10,
				'max_val'	=> 25,	
				'step'		=> 1,
				'def'		=> 16,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_is_txt_size' => array(
				'label' 	=> __("Texts font size (initial mode)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 8,
				'max_val'	=> 23,	
				'step'		=> 1,
				'def'		=> 14,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_ism_title_size' => array(
				'label' 	=> __("Titles font size (initial mode - mobile)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 10,
				'max_val'	=> 25,	
				'step'		=> 1,
				'def'		=> 14,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_ism_txt_size' => array(
				'label' 	=> __("Texts font size (initial mode - mobile)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 8,
				'max_val'	=> 23,	
				'step'		=> 1,
				'def'		=> 12,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'spcr2' => array(
				'type' => 'spacer',
			), 
			
			'nb_es_title_size' => array( // TODO - line height is 8px more than this for tiles and 7px more for texts
				'label' 	=> __("Titles font size (expanded mode)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 10,
				'max_val'	=> 35,	
				'step'		=> 1,
				'def'		=> 21,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_es_txt_size' => array(
				'label' 	=> __("Texts font size (expanded mode)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 8,
				'max_val'	=> 28,	
				'step'		=> 1,
				'def'		=> 14,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_esm_title_size' => array(
				'label' 	=> __("Titles font size (expanded mode - mobile)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 10,
				'max_val'	=> 25,	
				'step'		=> 1,
				'def'		=> 18,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_esm_txt_size' => array(
				'label' 	=> __("Texts font size (expanded mode - mobile)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 8,
				'max_val'	=> 23,	
				'step'		=> 1,
				'def'		=> 12,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
		),
	),
	
	
	
	'styling' => array(
		'sect_name'	=>  __('Styling', $ml_key),
		'fields' 	=> array(
			
			'nb_main_style' => array(
				'type'		=> 'custom',
				'callback'	=> 'nb_preset_styles',
				'validation'=> array(
					array('index' => 'nb_main_style', 'label' => 'Preset style'),
				)
			), 
			'nb_custom_style' => array(
				'label' => __('Use custom style?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __('If checked, applies custom styling settings to boxes', $ml_key),
			),  
		),
	),
	
	
	
	'cs_layout' => array(
		'sect_name'	=>  __('Custom style - Layout', $ml_key),
		'fields' 	=> array(
			
			'nb_img_margin' => array(
				'label' 	=> __("Image's margin", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 20,	
				'step'		=> 1,
				'def'		=> 0,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> __("Define space between box's edge and image in initial mode", $ml_key),
			),
			'nb_box_margin' => array( 
				'label' 	=> __("News margin <small>(boxed style)</small>", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 20,	
				'step'		=> 1,
				'def'		=> 0,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_border_w' => array( 
				'label' 	=> __("Boxes border's width", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 20,	
				'step'		=> 1,
				'def'		=> 4,
				'value'		=> 'px',
                'respect_limits' => true,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_border_radius' => array( 
				'label' 	=> __("Boxes border radius", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 20,	
				'step'		=> 1,
				'def'		=> 4,
				'value'		=> 'px',
                'respect_limits' => true,
				'required'	=> true,
				'note' 		=> ''
			),
			'nb_use_shadows' => array(
				'label' => __('Use shadows on hover?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> ''
			), 
			'nb_exp_img_padding' => array( 
				'label' 	=> __("Image's border width <small>(expanded mode)</small>", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 15,	
				'step'		=> 1,
				'def'		=> 5,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note' 		=> ''
			), 
		),
	),
	
	
	
	
	'cs_colors' => array(
		'sect_name'	=>  __('Custom style - Colors', $ml_key),
		'fields' 	=> array(
			
			
			'nb_loader_color' => array(
				'label' 	=> __("Loader color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#999999',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'nb_bg_color' => array(
				'label' 	=> __("News background color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#ffffff',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_title_color' => array(
				'label' 	=> __("Titles color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#444444',
                'extra_modes' => false,
				'required'	=> true,
			),
			'nb_txt_color' => array(
				'label' 	=> __("Texts color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#555555',
                'extra_modes' => false,
				'required'	=> true,
			),
			'nb_link_color' => array(
				'label' 	=> __("Links color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#222222',
                'extra_modes' => false,
				'required'	=> true,
			),
			'nb_exp_img_bg' => array(
				'label' 	=> __("Image's border color <small>(expanded mode)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#eeeeee',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'spcr1' => array(
				'type' => 'spacer',
			), 
			
			'nb_border_color' => array(
				'label' 	=> __("News borders color <small>(default state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#a6a6a6',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'nb_border_color_h' => array(
				'label' 	=> __("News borders color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#8c8c8c',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'spcr2' => array(
				'type' => 'spacer',
			), 
			
			'nb_btn_color' => array(
				'label' 	=> __("Icons color <small>(default state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#666666',
                'extra_modes' => array('alpha'),
				'required'	=> true,
				'note'		=> __("Applied to social share, link, expand and navigation arrow icons", $ml_key),
			),
			'nb_btn_color_h' => array( // TODO - implement it
				'label' 	=> __("Icons color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#525252',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'nb_sep_color' => array(
				'label' 	=> __("Icons separator and title border color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#cfcfcf',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'spcr3' => array(
				'type' => 'spacer',
			), 
			
			'nb_ol_icon_color' => array(
				'label' 	=> __("Overlay icon's color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#ffffff',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'nb_ol_bg_color' => array(
				'label' 	=> __("Overlay background's color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#222222',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_ol_bg_opacity' => array(
				'label' 	=> __("Overlay background's opacity", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 100,	
				'step'		=> 5,
				'def'		=> 80,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
				'note' 		=> ''
			), 
			'spcr4' => array(
				'type' => 'spacer',
			), 
			
			'nb_date_bg' => array(
				'label' 	=> __("Date / Read More box - background color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#F3F3F3',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_date_txt_col' => array( // TODO - implement it
				'label' 	=> __("Date / Read More box - text color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#666666',
                'extra_modes' => false,
				'required'	=> true,
			),
			'nb_date_bg_h' => array(
				'label' 	=> __("Read More box - background color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#E8E8E8',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_date_txt_col_h' => array(
				'label' 	=> __("Read More box - text color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#333333',
                'extra_modes' => false,
				'required'	=> true,
			),
			'spcr5' => array(
				'type' => 'spacer',
			), 
			
			// TODO - implement it
			'nb_lb_bg' => array(
				'label' 	=> __("Lightbox background color", $ml_key),
				'type'		=> 'color',
				'def'		=> '#222222',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_lb_bg_opacity' => array(
				'label' 	=> __("Lightbox background opacity", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 100,	
				'step'		=> 5,
				'def'		=> 70,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
				'note' 		=> ''
			), 
			
			'nb_lb_cmd_bg' => array(
				'label' 	=> __("Lightbox - commands background color <small>(default state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#eeeeee',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_lb_cmd_col' => array(
				'label' 	=> __("Lightbox - commands icon color <small>(default state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#666666',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
			'nb_lb_cmd_bg_h' => array(
				'label' 	=> __("Lightbox - commands background color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#fefefe',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'required'	=> true,
			),
			'nb_lb_cmd_col_h' => array(
				'label' 	=> __("Lightbox - commands icon color <small>(hover state)</small>", $ml_key),
				'type'		=> 'color',
				'def'		=> '#444444',
                'extra_modes' => array('alpha'),
				'required'	=> true,
			),
		),
	),
);	
	
	



####################################
########### CUSTOM CSS #############
####################################		
$structure['cust_css'] = array(	
	
	'custom_css_wrap' => array(
		'sect_name'	=>  __('High-priority code - applied to Swift Box elements', $ml_key),
		'fields' 	=> array(
		
			'nb_custom_css' => array(
				'label' 	=> __('Custom CSS', $ml_key),
				'type'		=> 'code_editor',
				'language'	=> 'css',
			),
		),
	),
	
	'legend' => array(
		'sect_name'	=>  __('Elements legend', $ml_key),
		'fields' 	=> array(
			
			'nb_elems_legend' => array(
				'type'		=> 'custom',
				'callback'	=> 'nb_elems_legend_f',
			), 
		),
	),
);





// NB-FILTER - manipulate settings structure
$GLOBALS['nb_settings_structure'] = apply_filters('nb_settings_structure', $structure);
