<?php
// IMPLEMENTING TINYMCE LIGHTBOX
	
function nb_action_admin_init() {
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
		return;

	if ( get_user_option('rich_editing') == 'true') {
		add_filter( 'mce_external_plugins', 'nb_filter_mce_plugin');
		add_filter( 'mce_buttons', 'nb_filter_mce_button');
	}
}
add_action('admin_init', 'nb_action_admin_init');

	
function nb_filter_mce_button( $buttons ) {
	array_push( $buttons, '|', 'nb_btn');
	return $buttons;
}

function nb_filter_mce_plugin( $plugins ) {
	$plugins['NewsBox'] = NB_URL . '/js/tinymce_btn.js';
	return $plugins;
}




function nb_editor_btn_content() {
	if(strpos($_SERVER['REQUEST_URI'], 'post.php') === false && strpos($_SERVER['REQUEST_URI'], 'post-new.php') === false && !isset($GLOBALS['nb_tinymce_editor'])) {return false;}
	?>
    
    <div id="nb-shortcode-form" class="nb_displaynone">
    	<div class="nb_scw_wrap">
            <p>
                <label><?php _e('Choose one box', 'nb_ml') ?></label>
                <select name="nb_sc_type" id="nb_box_id"  autocomplete="off">
                    <?php
                    $items = get_terms('nb_boxes', 'hide_empty=0&orderby=name');
                    foreach($items as $box) {
                        echo '<option value="'.$box->term_id.'">'. esc_html($box->name) .'</option>';  
                    }
                    ?>
                </select>
            </p>
            <p>
                <input type="button" id="nb-shortcode-submit" class="button-primary" value="<?php esc_attr_e('Insert', 'nb_ml') ?>" name="submit" />
            </p>
        </div>	
    </div>    
    <?php
}
add_action('admin_footer', 'nb_editor_btn_content');
